<template>
  <div class="d-flex flex-column">
    <b-table
      ref="table"
      :current-page="currentPage"
      :fields="fields"
      :items="alertsFiltered"
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      :per-page="perPage"
      bordered
      hover
      small
      striped
    >
      <template #cell(details)="row">
        <div class="text-center">
          <base-button-icon
            :icon="row.detailsShowing ? 'eye-slash' : 'eye'"
            color="gray"
            @click="row.toggleDetails"
          />
        </div>
      </template>
      <template #row-details="row">
        <locus-alert-details :alert-id="row.item.alert_id" />
      </template>
    </b-table>
    <div class="align-items-start d-flex justify-content-between">
      <div>
        <b-form inline>
          <label class="mr-2">Show</label>
          <b-form-select
            v-model="perPage"
            :options="pageOptions"
            class="mr-2"
          />
          <label class="mr-1">entries</label>
        </b-form>
        <p class="font-weight-lighter">
          Showing {{ pageStart }} to {{ pageEnd }} of {{ rows }} entries
        </p>
      </div>
      <b-pagination
        v-model="currentPage"
        :per-page="perPage"
        :total-rows="rows"
        align="right"
      />
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable func-names, @typescript-eslint/no-this-alias, prefer-rest-params,
  no-param-reassign, no-restricted-globals, no-underscore-dangle
*/

/*
TODO: this currently hard-codes the chart group to "default". I would
like to get the chart group from the view properties, but I don't know how
to do that in Vue.
*/
import Vue from 'vue';
import BaseButtonIcon from '@/components/BaseButtonIcon.vue';
import LocusAlertDetails from '@/components/LocusAlertDetails.vue';
import * as charts from '@/vis/chartTyped';

// https://stackoverflow.com/a/24004942
function debounce(func, wait, immediate) {
  let timeout;

  return function () {
    const context = this;
    const args = arguments;

    const callNow = immediate && !timeout;

    clearTimeout(timeout);

    timeout = setTimeout(() => {
      timeout = null;

      if (!immediate) {
        func.apply(context, args);
      }
    }, wait);

    if (callNow) func.apply(context, args);
  };
}

export default Vue.extend({
  components: {
    BaseButtonIcon,
    LocusAlertDetails,
  },

  props: {
    locus: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      currentPage: 1,
      fields: [
        {
          key: 'ant_mjd',
          label: 'MJD',
          sortable: true,
          formatter: (value) => {
            if (value) {
              return value.toFixed(2); // 10e-2 ~= 15 minute resolution
            }
            return value;
          },
        },
        {
          key: 'ant_passband',
          label: 'Filter',
          sortable: true,
        },
        {
          key: 'frontend_mag',
          label: 'Mag.',
          sortable: true,
          formatter: (value) => {
            if (value) {
              return value.toFixed(2);
            }
            return value;
          },
        },
        {
          key: 'frontend_magerr',
          label: 'Mag. Error',
          sortable: true,
          formatter: (value) => {
            if (value) {
              return value.toFixed(2);
            }
            return value;
          },
        },
        {
          key: 'details',
          label: 'Alert Packet',
        },
      ],
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 10,
      sortBy: 'ant_mjd',
      sortDesc: true,
    };
  },

  computed: {
    rows() {
      return this.alertsFiltered.length;
    },
    pageStart() {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    pageEnd() {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    alertsFiltered() {
      const predicate = charts.getSelectionPredicate('default', 'table');

      // here, we're working around a vue problem where filtering on managed data is
      // much slower than expected because of dependency tracking.
      //
      // 2021-04-13: however, _somehow_ this.nonReactiveLightcurve apparently ends up with _some_
      // reactive elements?! Specifically, entries that are actual corrected magnitude entries end
      // up becoming reactive elements on this.nonReactiveLightcurve after alerts is loaded.
      //
      // this doesn't make our code _wrong_, but it does make it slow and it has befuddled me.

      return (this.nonReactiveLightcurve || []).filter((el) => {
        el = { ...el };
        return (
          !isNaN(el.frontend_mag)
          && predicate({
            payload: el,
            type: 'mag',
            getMag() {
              return this.payload.frontend_mag;
            },
          })
        );
      });
    },
  },

  mounted() {
    const that = this;
    this.nonReactiveLightcurve = Array.from(this.locus.lightcurve).map((el) => ({ ...el }));

    this.$forceUpdate(); // ugly, but necessary for alertsFiltered() to work.

    charts.chartStore.commit('predicate', {
      group: 'default',
      chartName: 'table',
      predicate: null,
    });
    // we debounce the table update at 10Hz to minimize jankiness.
    // A perceptive reader will also note that this is a
    // massive hack. The Vue deities are displeased.
    const debounced = debounce(
      () => {
        if (that._computedWatchers.alertsFiltered) {
          that._computedWatchers.alertsFiltered.run();
          that._computedWatchers.rows.run();
          that._computedWatchers.pageStart.run();
          that._computedWatchers.pageEnd.run();
          that.$forceUpdate();
        }
      },
      100,
      false,
    );
    charts.watchBrush('default', debounced);
  },
});
</script>

<style scoped>
  .table {
    table-layout: fixed;
  }
</style>
